package upn;

import java.util.*;

public class Parser {
	Deque<Expression> stack;
	
	public Expression parse(String line) {
		stack = new LinkedList<Expression>();
		String[] tokens = line.split(" ");
		for (String token : tokens) {
			Expression expression = null;
			try {
				// Check for floating point number
				double value = Double.valueOf(token);
				expression = new Number(value);
			} catch (NumberFormatException e) {
				// Create Expression instance for token
				expression = TokenMap.valueOf(token).getExpression();
				expression.visit(stack);
			}
			stack.push(expression);
		}
		if (stack.size()!=1) throw new RuntimeException("Stack length is not 1");
		return stack.pop();
	}
}